unit udmzeosgui;

{$mode ObjFPC}{$H+}

//Switches:
//You can disable switches by using a period after the curved
//bracket like this  {.$DEFINE SWITCHNAME}

//delete Databasefile before ZConnection1.Open so every start an new and empty file is created
{$DEFINE DeleteDatabasefileBeforeOpen}

//Import Data automatically on Create. You can use the procedure ImportData to import
//data at any given time
{.$DEFINE ImportDemoDataOnCreate}

interface

uses
  Classes, SysUtils, ZConnection, ZSqlProcessor, ZDataset, uguessfile, dialogs;

const
  {$include demosqlite.Inc}

type

  { TdmZeosGUI }

  TdmZeosGUI = class(TDataModule)
    ZConnection1: TZConnection;
    ZQuery1: TZQuery;
    ZSQLProcessor1: TZSQLProcessor;
    procedure DataModuleCreate(Sender: TObject);
  private

  public
    procedure ImportData(sImportFile:string='');
    procedure OpenConnection;
    procedure CloseConnection;
    procedure Initialize;
  end;

var
  dmZeosGUI: TdmZeosGUI;

implementation

{$R *.lfm}

{ TdmZeosGUI }

procedure TdmZeosGUI.DataModuleCreate(Sender: TObject);
begin
  initialize;
end;

procedure TdmZeosGUI.ImportData(sImportFile: string);
begin
  if sImportfile = '' then begin
     sImportFile := GuessSQLImportFile;
     if sImportFile = cUNDEF then begin //just in case
        showmessage( 'SQL import file not found');
        exit;
     end
  end;
  if not FileExists(sImportFile) then begin
     showmessage('ImportData: File ' + sImportFile +'does not exist');
     exit;
  end;
  try
    ZSQLProcessor1.Script.LoadFromFile(sImportFile);
    ZSQLProcessor1.Execute;
  finally
    //
  end;

end;

procedure TdmZeosGUI.OpenConnection;
begin
  if not ZConnection1.Connected then ZConnection1.Connect;
end;

procedure TdmZeosGUI.CloseConnection;
begin
  if ZConnection1.Connected then ZConnection1.Disconnect;
end;

procedure TdmZeosGUI.Initialize;
var
  sLibrary:string;
  sSQLfile:string;
  sSearched:string;
  sPathstring:string;
begin
  CloseConnection;  //in case ZConnection1 were active in design mode close them

  //*************** First: load library
  sLibrary :='';
  sLibrary := GuessLibraryLocation;              //Search for sqlite Library

  if sLibrary = cUNDEF then exit;               //for security reasons in case the exception fails



  //*************** Second: Try to find the SQLite Database file
  //        If it does not exist SQLite creates the named database file automatically on first Open
  {$ifdef DeleteDatabasefileBeforeOpen}
     //DeleteDatabasefile
  {$else}
  {$endif}


  {$ifdef Unix}
  sPathString:='to define'
  {$else}
  sPathString := 'data@sql';
  {$endif}
  sSearched:='';
  sSQLFile := GuessFile(cSQLDatabaseFile,sPathString,sSearched);
  if sSQLFile = cUNDEF then begin //create an new one and search again
     showmessage('No database file found - searched in' + LineEnding+ sSearched + LineEnding + ' creating standard database named '+cSQLDatabaseFile+' instead');
     sSQLFile:=cSQLDatabaseFile;
  end;

  // establish a connection to the database
  // if the named database file is missing, a new one will be created on ZConnection1.Open
  ZConnection1.LibraryLocation:=sLibrary;
  ZConnection1.Protocol:=cProtocol;
  ZConnection1.Database:=sSQLFile;

  if ZQuery1.Active then ZQuery1.Close;
  ZQuery1.Connection:=ZConnection1;

  OpenConnection;

  //*************** Third: Import demo data
  {$ifdef ImportDemoDataOnCreate}
    ImportData;
  {$endif}

end;


end.

